#ifndef EMBEDRUBY_LIBRARY_H
#define EMBEDRUBY_LIBRARY_H

#include <stdexcept>
#include <iostream>

namespace EMBEDRUBY {

/*
purpose:
start/stop this library

constraints:
*	lib_begin() must be invoked before using this library.
*	lib_end() must be invoked after using this library.
*/
void lib_begin();
void lib_end();


/*
purpose:
base class for errors
*/
class Error : public std::exception {
public:
	virtual void explain(std::ostream &o) const throw() = 0;
};


/*
purpose:
example base class, which you can inhierit from and 
overwrite repaint().

issues:
*	It has a hidden implementation, located in library.cpp.
*/
class Impl; // pimpl
class View {
public:
	View();
	virtual ~View();

	void insert();
	virtual void repaint();
private:
	Impl *pimpl;
};

} // end of namespace EMBEDRUBY

#endif // EMBEDRUBY_LIBRARY_H
