#include <iostream>
#include <stdexcept>
#include <signal.h>

#include "library.h"

using std::cout;
using std::cerr;
using std::endl;
using std::exception;

class ViewQT : public EMBEDRUBY::View {
public:
	void repaint() {
		cout << "viewqt.repaint: bingo" << endl;
		//throw std::runtime_error("deal with me");
	}
};

void Test1() {
	ViewQT v;
	v.insert();
}

void Test2() {
	cout << "[1]" << endl;
	ViewQT a;
	a.insert();
	cout << "[2]" << endl;
	ViewQT b;
	b.insert();
	cout << "[3]" << endl;
	a.insert();
	cout << "[4]" << endl;
	ViewQT c;
	c.insert();
	cout << "[5]" << endl;
}

void TestAll() {
	#define TEST(number, name) { \
		cout << "-- Test" << number << " " << \
			name << " ---------------------- " << endl; \
		Test##number(); \
	}
	TEST(1, "simple");
	TEST(2, "multiple instances");
	#undef TEST
	cout << "-- End ------------------------------------" << endl;
}

int SafeMain() {
	try {
		EMBEDRUBY::lib_begin();
		TestAll();
		EMBEDRUBY::lib_end();
		return 0;
	} catch(const EMBEDRUBY::Error &e) {
		cerr << "EXCEPTION (RUBY):" << endl;
		e.explain(cerr);
		return 1;
	} catch(const exception &e) {
		cerr << "EXCEPTION=" << e.what() << endl;
		return 1;
	}
}

void sig_handler(int x) {
	cerr << "something bad happened! x=" << x << endl;
	exit(-1);
}

int main() {
	cout << "main: enter" << endl;
	signal(SIGABRT, sig_handler);
	int status = SafeMain();
	cout << "main: leave (" << status << ")" << endl;
	return status;
}
